% M106 Winter 2019, Data-driven UQ
% by Yoonsang Lee (yoonsang.lee@dartmouth.edu)
%
% Lecture 9: MCMC
%
% Markov Chain Monte Carlo sample using
% the Metropolis-Hastings Algorithm
%
% Last update: Jan 22, 2019

target = @(theta) 1/(1+theta.^2)/pi;

b=1; % Variance of the proposal Gaussian denstiy

niters = 10000;
naccept = 0;

theta = 0; % initial value for the Markov chain

samples = zeros(niters+1,1);
samples(1) = theta;

for i=1:niters
    theta_p = theta + randn()*b;
    rho = min(1, target(theta_p)/target(theta));
    u = rand();
    if u<rho
        naccept = naccept+1;
        theta = theta_p;
    end
    samples(i+1)=theta;
end
